

// one simulation element, e.g. one job for a machine to process

public class JSElt  

{  // class variables and functions

   public static JSElt JSSchedListHd;
   public static JSElt JSCurrEvnt;

   // removes head of event list and assigns JSCurrEvnt to it
   public static void JSGetNext()

   {  JSElt OldSchedListHd;

      OldSchedListHd  = JSSchedListHd;
      if (JSSchedListHd.JSNext == null)
         JSSchedListHd = null;
      else JSSchedListHd = JSSchedListHd.JSNext;
      JSCurrEvnt = OldSchedListHd;
   }

   // removes earliest element in event list having JSEltNum value EN
   public static void JSCancel(int EN)

   {  JSElt TmpEltPtr = JSSchedListHd;

      if (TmpEltPtr == null) return;

      if (TmpEltPtr.JSEltNumber == EN)  {
         JSSchedListHd = TmpEltPtr.JSNext;
         return;
      }

      while (TmpEltPtr.JSNext != null)  {
         if (TmpEltPtr.JSNext.JSEltNumber == EN)  {
            TmpEltPtr.JSNext = TmpEltPtr.JSNext.JSNext;
            return;
         }
         TmpEltPtr = TmpEltPtr.JSNext;   
      }
   
   }

   // prints out the entire event list
   public static void JSPrintSchedList()

   {  JSElt TmpEltPtr = JSSchedListHd;

      while (TmpEltPtr != null)  {
         TmpEltPtr.JSPrintElt();
         TmpEltPtr = TmpEltPtr.JSNext;   
      }
   
   }

   // checks for specified event type
   boolean JSEvntMatch(String S)

   {  return (JSCurrEvnt.JSName.equals(S)); }

   // instance variables and functions

   public String JSName;  // name, for debugging purposes
   public float JSEvntTime;  // event occurrence time
   public int JSEltNumber;  // ID number
   public JSElt JSNext;  // pointer to next in event list
   
   // constructor function
   public JSElt() {  JSEltNumber = JSSim.JSNextNew++; }

   // insert this element into schedule list
   public void JSInsertInSchedList()  

   {  JSElt Tmp;

      JSNext = null;  // make sure no loose ends

      if (JSSchedListHd == null)  {
         JSSchedListHd = this;
         return;
      }

      if (JSEvntTime < JSSchedListHd.JSEvntTime)  {
         JSNext = JSSchedListHd;
         JSSchedListHd = this;
         return;
      }

      Tmp = JSSchedListHd;
      while (true) {
         if (Tmp.JSNext == null)  {
            Tmp.JSNext = this;
            break;
         }
         else if (JSEvntTime < Tmp.JSNext.JSEvntTime)  {
            JSNext = Tmp.JSNext;
            Tmp.JSNext = this;
            break;
         }
         Tmp = Tmp.JSNext;
      }
   }

   public void JSPrintElt()

   {  System.out.println("JSElt "+this.JSEltNumber+":  "
           +this.JSName+" at "+this.JSEvntTime);
   }
      
}



